//+------------------------------------------------------------------+
//|                                                    Color CCI.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
//CCI_Color_CCI_v1.01_maxsig
//add. SignalScreanMultiplier (sig.history)
#property copyright "mladen"


#property description " * * * * * * * * * * *"
#property description " * poruchik * 1.06.16"
#property description " "
#property description " * updated (from jagg) for use with cci scalping trade system by ioni72"
#property link      "http://www.forexfactory.com/showthread.php?t=637568"

#property strict
#property indicator_separate_window
#property indicator_buffers   7
//#property indicator_minimum   0
//#property indicator_maximum 100
//#property indicator_color1 clrDarkGray
//#property indicator_color2 clrDarkGreen
//#property indicator_color3 clrFireBrick
#property indicator_color4 clrDimGray
#property indicator_color5 clrDimGray //C'47,47,47'  
#property indicator_color6 clrLimeGreen
#property indicator_color7 clrRed

//#property indicator_width1 2
//#property indicator_width2 2
//#property indicator_width3 2

#property indicator_level1  200
#property indicator_level2  100
#property indicator_level3  -100
#property indicator_level4  -200
//#property indicator_level5  0
#property indicator_levelcolor clrDimGray
#property indicator_levelstyle STYLE_DOT

#define SignalName "CCISignal"

enum enum_PerfectSMA_for_Trade {
   SMA3, //SMA13>SMA200>SMA1000 (for green zero line)
   SMA2, //SMA13>SMA1000 AND SMA13>SMA200 is enough (for green zero line)
};

enum ZeroLineStyle {
   Line, //Solid Line
   Dotted, //Dotted Line
   Dashed, //Dashed Line
   Dots, //Dots (Symbol)
};

//---- input parameters

extern int       CCIPeriod          = 14; //CCI Period
extern ENUM_APPLIED_PRICE PriceType = PRICE_CLOSE; //Price Type (for CCI)
extern ENUM_TIMEFRAMES timeFrame    = PERIOD_CURRENT; //Time Frame (for CCI)
extern color     cci_color          = clrDarkGray; //CCI-Line color
extern int       SizeCCI            = 2; //Width of CCI Line?
extern int       SizeHistogram      = 1; //Width of CCI Histogram?
extern int       overBought         = 200; //UP-Level (when we look for buys)
extern color     overBought_color   = clrDarkGreen; //UP-Level color
extern int       overSold           = -200; //DONWN-Level (when we look for shorts)
extern color     overSold_color     = clrFireBrick; //DOWN-Level color
extern bool      MarkOnlyWhenSMAsArePerfect = true; //Mark overbough/oversold only when SMA vlaues are in sync?

extern string    s1="**********************************";

extern int       SMAPeriod1         = 13; //SMA Period 1
extern int       SMAPeriod2         = 200; //SMA Period 2
extern int       SMAPeriod3         = 1000; //SMA Period 3 
extern int       LineSize           = 2; //Line Size for SMA (zero line of CCI)
extern ZeroLineStyle LineStyle      = Dots; //Line Style for SMA (zero line of CCI)
extern enum_PerfectSMA_for_Trade PerfectSMA_for_Trade = SMA2; //SMA requirements to have green/red zero line


extern string    s2="**********************************";
extern bool      showArrows         = false; //Show arrow in chart when up-/down level is reached?
extern int       MaxArrowsScreensX  = 2;


extern string    s3="**********************************";
extern bool      alertsOn           = false; //Use Alerts?
extern bool      alertsMessage      = true; //Show PopUp Alert?
extern bool      alertsSound        =true; //Play Alert Sound?
extern bool      alertsEmail        = false; //Send Email Alert?


extern string    s4="**********************************";
extern int       repaintSignalStep  =  0;
extern int       repaintSignalPrice =  0;

//---- buffers
//
//
//
//
//

double   CCIBuffer[];
double   HistBuffer[];
double   ZerolineBuffer[];
double   ZerolineBuffer_SMA_UP[];
double   ZerolineBuffer_SMA_DOWN[];
double   SMAPeriod1_value[],SMAPeriod2_value[],SMAPeriod3_value[];
bool     SMA_requirement_ok;
double   Upper[];
double   Lower[];
double   Prices[];

//
//

int      TimeFrame;
datetime TimeArray[];
int      maxArrows;
int      SignalGap;
string   prevSignal;
int      prevBar;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   string shortName  = "CCI (";
   //SetIndexStyle(0, DRAW_LINE, STYLE_SOLID,SizeHistogram);
      SetIndexBuffer(0,CCIBuffer);
      SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, SizeCCI, cci_color);
      SetIndexBuffer(1,Upper);
      SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, SizeCCI, overBought_color);
      SetIndexBuffer(2,Lower);
      SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, SizeCCI, overSold_color);

   SetIndexStyle(3, DRAW_HISTOGRAM, 0, SizeHistogram);
   SetIndexBuffer(3, HistBuffer);
   if (LineStyle == Dots) {
      SetIndexStyle(4, DRAW_ARROW, STYLE_SOLID, LineSize);
      SetIndexStyle(5, DRAW_ARROW, STYLE_SOLID, LineSize, overBought_color);
      SetIndexStyle(6, DRAW_ARROW, STYLE_SOLID, LineSize, overSold_color);
      SetIndexArrow(4,158);
      SetIndexArrow(5,158);
      SetIndexArrow(6,158);
   } else if (LineStyle == Dotted) {
      SetIndexStyle(4, DRAW_LINE, STYLE_DOT, LineSize);
      SetIndexStyle(5, DRAW_LINE, STYLE_DOT, LineSize, overBought_color);
      SetIndexStyle(6, DRAW_LINE, STYLE_DOT, LineSize, overSold_color);
   } else if (LineStyle == Dashed) {
      SetIndexStyle(4, DRAW_LINE, STYLE_DASH, LineSize);
      SetIndexStyle(5, DRAW_LINE, STYLE_DASH, LineSize, overBought_color);
      SetIndexStyle(6, DRAW_LINE, STYLE_DASH, LineSize, overSold_color);
   } else if (LineStyle == Line) {
      SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, LineSize);
      SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, LineSize, overBought_color);
      SetIndexStyle(6, DRAW_LINE, STYLE_SOLID, LineSize, overSold_color);
   }
   SetIndexBuffer(4, ZerolineBuffer); 
   SetIndexBuffer(5, ZerolineBuffer_SMA_UP); 
   SetIndexBuffer(6, ZerolineBuffer_SMA_DOWN); 
   

      SetIndexLabel(0, "CCI");
      SetIndexLabel(1, NULL);
      SetIndexLabel(2, NULL);
      SetIndexLabel(3, NULL);   
      SetIndexLabel (4, NULL);
      SetIndexLabel (5, NULL);
      SetIndexLabel (6, NULL);
         //
         //
         //
         //
         //
         

      TimeFrame         = stringToTimeFrame(IntegerToString(timeFrame));
      if (TimeFrame != Period()) shortName  = shortName+TimeFrameToString(TimeFrame)+",";
                                 shortName  = shortName+PriceTypeToString(PriceType);
      
            if (overBought < overSold) overBought = overSold;
            if (overBought < 100)      shortName  = shortName+","+IntegerToString(overBought);
            if (overSold   >   0)      shortName  = shortName+","+IntegerToString(overSold);
      IndicatorShortName(shortName+") ("+IntegerToString(CCIPeriod)+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   DeleteArrows();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   //int    counted_bars=IndicatorCounted();
   //int    limit;
   int    i,y;
   
   //if(counted_bars<0) return(-1);
   //if(counted_bars>0) counted_bars--;
   //      limit=MathMax(Bars-counted_bars,TimeFrame/Period());
   ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
         
   //--- the number of bars that have not changed since the last indicator call
   int counted_bars=myIndicatorCounted();
   //--- exit if an error has occurred
   if(counted_bars<0) return(-1);
      
   //--- position of the bar from which calculation in the loop starts
   int limit=Bars-counted_bars;

   //--- if counted_bars=0, reduce the starting position in the loop by 1,   
   if(counted_bars==0) 
     {
      limit--;  // to avoid the array out of range problem when counted_bars==0
      //--- we use a shift of 10 bars back in history, so add this shift during the first calculation
      limit-=10;
     }
   else //--- the indicator has been already calculated, counted_bars>0
     {     
      //--- for repeated calls increase limit by 1 to update the indicator values for the last bar
      limit++;
     } 
   // DEBUG
   //Print("***DEBUG*** Bars: ",Bars," / counted_bars: ",counted_bars," / limit: ",limit); // limit should mostly be "2"
      
   //--- the main calculation loop
   for(i=0,y=0; i<limit; i++)
      {
            if(Time[i]<TimeArray[y]) y++;
               CCIBuffer[i] = iCCI(NULL,TimeFrame,CCIPeriod,PriceType,y);
               HistBuffer[i] = CCIBuffer[i];
               ZerolineBuffer[i] = 0;
               ZerolineBuffer_SMA_UP[i] = EMPTY_VALUE;
               ZerolineBuffer_SMA_DOWN[i] = EMPTY_VALUE;
                
               //SMAPeriod1_value[i] = iMA(NULL, TimeFrame, SMAPeriod1, 0, MODE_SMA, PRICE_CLOSE, y);
               //SMAPeriod2_value[i] = iMA(NULL, TimeFrame, SMAPeriod2, 0, MODE_SMA, PRICE_CLOSE, y);
               //SMAPeriod3_value[i] = iMA(NULL, TimeFrame, SMAPeriod3, 0, MODE_SMA, PRICE_CLOSE, y);
               //Print("***DEBU*** SMAPeriod1_value["+i+"]: y:"+y+" -",iMA(NULL, TimeFrame, SMAPeriod1, 0, MODE_SMA, PRICE_CLOSE, y)," SMAPeriod2_value["+i+"]: ",SMAPeriod2_value[i]," SMAPeriod3_value["+i+"]: ",SMAPeriod3_value[i] );
            

      }
   for(i=limit; i>=0; i--)
      {
            if (!MarkOnlyWhenSMAsArePerfect) {
               if (CCIBuffer[i] > overBought) { Upper[i] = CCIBuffer[i]; Upper[i+1] = CCIBuffer[i+1]; }
               else                           { Upper[i] = EMPTY_VALUE;
                                              if (Upper[i+2] == EMPTY_VALUE)
                                                  Upper[i+1]  = EMPTY_VALUE; }
               if (CCIBuffer[i] < overSold)   { Lower[i] = CCIBuffer[i]; Lower[i+1] = CCIBuffer[i+1]; }
               else                           { Lower[i] = EMPTY_VALUE;
                                              if (Lower[i+2] == EMPTY_VALUE)
                                                  Lower[i+1]  = EMPTY_VALUE; }
            }                                
            //---- Color Middle Line SMA    
            double SMAPeriod1_val = iMA(NULL, TimeFrame, SMAPeriod1, 0, MODE_SMA, PRICE_CLOSE, i);
            double SMAPeriod2_val = iMA(NULL, TimeFrame, SMAPeriod2, 0, MODE_SMA, PRICE_CLOSE, i);
            double SMAPeriod3_val = iMA(NULL, TimeFrame, SMAPeriod3, 0, MODE_SMA, PRICE_CLOSE, i);
            
            if (PerfectSMA_for_Trade == SMA3) {
               // Buy signal valid only if SMA13 > SMA200 > SMA1000
               if ((SMAPeriod1_val > SMAPeriod2_val) && (SMAPeriod2_val > SMAPeriod3_val)) {
                  SMA_requirement_ok = true;
               } else {
                  SMA_requirement_ok = false;
               }
            } else if (PerfectSMA_for_Trade == SMA2) {
               // Buy signal valid if SMA13 > SMA1000
               //if (MA13_val > MA1000_val) {
               // Buy signal valid only if SMA13>SMA1000 AND SMA13>SMA200
               if ((SMAPeriod1_val > SMAPeriod3_val) && (SMAPeriod1_val > SMAPeriod2_val)) {
                  SMA_requirement_ok = true;
               } else {
                  SMA_requirement_ok = false;
               }
            }
                                    
            if (SMA_requirement_ok) {
               ZerolineBuffer_SMA_UP[i] = 0;
               ZerolineBuffer[i] = EMPTY_VALUE;
               
               if (MarkOnlyWhenSMAsArePerfect) {
                  if (CCIBuffer[i] > overBought) { Upper[i] = CCIBuffer[i]; Upper[i+1] = CCIBuffer[i+1]; }
                  else                           { Upper[i] = EMPTY_VALUE;
                                              if (Upper[i+2] == EMPTY_VALUE)
                                                Upper[i+1]  = EMPTY_VALUE; }
               }
            }

            if (PerfectSMA_for_Trade == SMA3) {
               // Short signal valid only if SM13 < SMA200 < SMA1000
               if ((SMAPeriod1_val < SMAPeriod2_val) && (SMAPeriod2_val < SMAPeriod3_val)) {
                  SMA_requirement_ok = true;
               } else {
                  SMA_requirement_ok = false;
               }
            } else if (PerfectSMA_for_Trade == SMA2) {
               // Short signal valid only if SM13 < SMA1000
               // if (MA13_val < MA1000_val) {
               // Short signal valid only if SMA13<SMA1000 AND SMA13<SMA200
               if ((SMAPeriod1_val < SMAPeriod3_val) && (SMAPeriod1_val < SMAPeriod2_val)) {
                  SMA_requirement_ok = true;
               } else {
                  SMA_requirement_ok = false;
               }
            }            
            
            if (SMA_requirement_ok) {
               ZerolineBuffer_SMA_DOWN[i] = 0;
               ZerolineBuffer[i] = EMPTY_VALUE;
               
               if (MarkOnlyWhenSMAsArePerfect) {
                  if (CCIBuffer[i] < overSold)   { Lower[i] = CCIBuffer[i]; Lower[i+1] = CCIBuffer[i+1]; }
                  else                           { Lower[i] = EMPTY_VALUE;
                                              if (Lower[i+2] == EMPTY_VALUE)
                                                  Lower[i+1]  = EMPTY_VALUE; }
               }
            }
      }
      

   
   //
   //
   //
   //
   //
   
   DeleteArrows();
   if (showArrows)
      {
         SignalGap = (int)MathCeil(iATR(NULL,0,50,0)/Point);
         for (i=WindowBarsPerChart()*MaxArrowsScreensX; i>=0 ;i--)
            {
               if (CCIBuffer[i]>overBought && CCIBuffer[i+1]<overBought) DrawArrow(i,"up");
               if (CCIBuffer[i]<overSold   && CCIBuffer[i+1]>overSold)   DrawArrow(i,"down");
               
               //
               //
               //    should we try to repaint the previous alert signal
               //
               //
               
               if ((TimeFrame==Period()) && (repaintSignalStep>0))
               if (prevBar==i+1)
               {
                  double currPrice = iMA(NULL,0,1,0,MODE_SMA,repaintSignalPrice,i);
                  double prevPrice = iMA(NULL,0,1,0,MODE_SMA,repaintSignalPrice,i+1);
                  
                  //
                  //
                  //
                  //
                  //
                  
                  if (prevSignal == "down")
                     if (CCIBuffer[i]<overSold)
                     if ((prevPrice-currPrice)/Point >= repaintSignalStep)
                        {
                           ObjectSet(StringConcatenate(SignalName,maxArrows),OBJPROP_TIME1,Time[i]);
                           ObjectSet(StringConcatenate(SignalName,maxArrows),OBJPROP_PRICE1,Low[i] -(SignalGap*Point));
                        }
                  if (prevSignal == "up")
                     if (CCIBuffer[i]>overBought)
                     if ((currPrice-prevPrice)/Point >= repaintSignalStep)
                        {
                           ObjectSet(StringConcatenate(SignalName,maxArrows),OBJPROP_TIME1,Time[i]);
                           ObjectSet(StringConcatenate(SignalName,maxArrows),OBJPROP_PRICE1,High[i]+(SignalGap*Point));
                        }
                }                              
            }
      }            

   //
   //
   //
   //
   
   if (alertsOn) {
            if (CCIBuffer[1]>overBought && CCIBuffer[2]<overBought) doAlert(IntegerToString(overBought)+" line crossed up");
            if (CCIBuffer[1]<overSold   && CCIBuffer[2]>overSold)   doAlert(IntegerToString(overBought)+" line crossed down");
         }

   //
   //
   //
   //
   //
 
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void DrawArrow(int i,string type)
{
   string name;
      
   maxArrows++;
   name = StringConcatenate(SignalName,maxArrows);
         ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         if (type=="up")
            {
               ObjectSet(name,OBJPROP_PRICE1,High[i]+(SignalGap*Point));
               ObjectSet(name,OBJPROP_ARROWCODE,242);
               ObjectSet(name,OBJPROP_COLOR,Red);
            }
         else
            {
               ObjectSet(name,OBJPROP_PRICE1,Low[i]-(SignalGap*Point));
               ObjectSet(name,OBJPROP_ARROWCODE,241);
               ObjectSet(name,OBJPROP_COLOR,LimeGreen);
            }
   prevSignal = type;
   prevBar    = i;
}
void DeleteArrows()
{
   while(maxArrows>0) { ObjectDelete(StringConcatenate(SignalName,maxArrows)); maxArrows--; }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];
      
          //
          //
          //
          //
          //
            
          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," CCI ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsSound)   PlaySound("alert2.wav");
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," CCI crossing"),message);
      }        
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string PriceTypeToString(int pt)
{
   string answer;
   switch(pt)
   {
      case 0:  answer = "Close"    ; break; 
      case 1:  answer = "Open"     ; break;
      case 2:  answer = "High"     ; break;
      case 3:  answer = "Low"      ; break;
      case 4:  answer = "Median"   ; break;
      case 5:  answer = "Typical"  ; break;
      case 6:  answer = "Wighted"  ; break;
      default: answer = "Invalid price field requested";
                                    Alert(answer);
   }
   return(answer);
}
int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="Current time frame";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      character;
   
   while(lenght >= 0)
      {
         character = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((character > 96 && character < 123) || (character > 223 && character < 256))
                  s = StringSetChar(s, lenght, (ushort)(character - 32));
         else 
              if(character > -33 && character < 0)
                  s = StringSetChar(s, lenght, (ushort)(character + 224));
         lenght--;
   }
   
   //
   //
   //
   //
   //
   
   return(s);
}


//+------------------------------------------------------------------+
// http://www.forexfactory.com/showthread.php?p=5816814#post5816814
// ...works also in offline charts
int myIndicatorCounted()
{
   
   int counted;    
   datetime        timeBar0=Time[0];
   static datetime last_timeBar0;
   static int      last_Bars;
   if ( Bars - last_Bars >= 2) counted = 0;
   else
   {
      timeBar0 = Time[0];
      if (timeBar0 == last_timeBar0) counted = Bars-1;
      else
      {
         if ((timeBar0 - last_timeBar0)/(60*Period() ) == 1) counted = Bars-2;
         else counted = 0;
      }
   }
   
   last_Bars = Bars;
   last_timeBar0 = timeBar0;
   return(counted);
}
//+------------------------------------------------------------------+
